<template>
  <v-group :config="{x: 10, y: param.config.y}">
    <v-text :config="{x: 30, y: 0, text: `${param.name} : ${value()}`, fontSize: 14}" />
    <v-line :config="param.config.lineConfig" />
    <v-circle
      :config="param.config.circleConfig"
      @mousedown="$event.cancelBubble=true"
      @dragmove="dragmove"
      @dragstart="$event.cancelBubble=true"
      @dragend="$event.cancelBubble=true"
    />
    <v-group :config="{x: 0, y: 20}">
      <v-group v-for="(port, i) in param.inputs" :key="`in-${i}`">
        <GraphicPort :port="port" />
      </v-group>
    </v-group>
  </v-group>
</template>

<script lang="ts">
import { NodeWrapper } from '@/lib/gui/wrappers/NodeWrapper'
import { ParamWrapper } from '@/lib/gui/wrappers/ParamWrapper'
import { mapMutations } from 'vuex';
import { ParamConfiguration } from '@/lib/gui/configs/ParamConfiguration';
import GraphicPort from "@/components/elements/GraphicPort.vue"

export default {
  name: "GraphicParam",
  props: {
    node: NodeWrapper,
    param: ParamWrapper,
    index: Number
  },
  components: {
    GraphicPort
  },
  methods: {
    value() {
      return (this as any).param.value.toFixed(2);
    },
    ...mapMutations([
      "setEditedParam",
      "setEditPosition",
    ]),
    edit(evt: any, config: ParamConfiguration) {
      this.setEditedParam(config.wrapper);
      this.setEditPosition(config.absoluteCoordinates());
      evt.cancelBubble = true;
    },
    dragmove($event: any) {
      $event.cancelBubble = true;
      (this as any).param.updateValue();
      (this as any).$forceUpdate();
    }
  }
}
</script>
